import emc
import os
import hal
import hal_glib
from gladevcp.persistence import IniFile,widget_defaults,set_debug,select_widgets

debug = 0

class HandlerClass:

## Setta i valori massimi dei meter:
	def _on_max_value_change1(self,hal_pin,data=None):
		self.meter1.max = float(hal_pin.get())
		self.meter1.queue_draw()
	def _on_max_value_change2(self,hal_pin,data=None):
		self.meter2.max = float(hal_pin.get())
		self.meter2.queue_draw()
	def _on_max_value_change3(self,hal_pin,data=None):
		self.meter3.max = float(hal_pin.get())
		self.meter3.queue_draw()

## Assegnazione kins_pins all'estop-reset:
	def _on_estop_reset(self,hal_pin,data=None):
		print "stampo il valore di spin1 per debug:"
		print (self.spin1_value.value)
		self.spin1_out.set(self.spin1_value.value)
		self.spin2_out.set(self.spin2_value.value)
		self.spin3_out.set(self.spin3_value.value)
		self.spin4_out.set(self.spin4_value.value)
		print self.spin1_out.value

## Save ini file:
	def on_hal_button9_pressed(self,widget,data=None):
		print "Button9 pressed - saving ini file:"
		nome = str()
		nome = (self.builder.get_object('entry1')).get_text()
		self.ini_filename = nome + '.ini'
		print nome
		self.ini = IniFile(self.ini_filename, self.defaults, self.builder)
		self.defaults = {IniFile.vars: {},
                         IniFile.widgets : widget_defaults(select_widgets(self.builder.get_objects(), hal_only=True,output_only = True))
						}
		self.ini.save_state(self)
		self.builder.get_object('comboboxentry1').append_text(nome)

## Load ini file:
	def on_hal_button8_pressed(self,widget,data=None):
		print "Button8 pressed - loading ini file:"
		nome = str()
		nome = (self.builder.get_object('comboboxentry1')).get_active_text()
		self.ini_filename = nome + '.ini'
		print nome
		self.ini = IniFile(self.ini_filename, self.defaults, self.builder)
		self.ini.restore_state(self)
		#### TODO: salva la liststore... ####

	def __init__(self, halcomp,builder,useropts):
		self.halcomp = halcomp
		self.builder = builder
		self.useropts = useropts

## Nel file salva solo i pin d'uscita:
		self.defaults = {IniFile.vars: {},
                         IniFile.widgets : widget_defaults(select_widgets(self.builder.get_objects(), hal_only=True,output_only = True))
						}

## Questo file init serve per settare i minimi dei meter:
		initfile = emc.ini("tgvcp_start_setup.ini")
		mmin = float(initfile.find("METER", "MIN") or 0.0)

## Setup dei meter e creazione pin:
		self.max_value1 = hal_glib.GPin(halcomp.newpin('max-value1',  hal.HAL_FLOAT, hal.HAL_IN))
		self.max_value1.connect('value-changed', self._on_max_value_change1)
		self.meter1 = self.builder.get_object('hal_meter1')
		self.meter1.min = mmin

		self.max_value2 = hal_glib.GPin(halcomp.newpin('max-value2',  hal.HAL_FLOAT, hal.HAL_IN))
		self.max_value2.connect('value-changed', self._on_max_value_change2)
		self.meter2 = self.builder.get_object('hal_meter2')
		self.meter2.min = mmin

		self.max_value3 = hal_glib.GPin(halcomp.newpin('max-value3',  hal.HAL_FLOAT, hal.HAL_IN))
		self.max_value3.connect('value-changed', self._on_max_value_change3)
		self.meter3 = self.builder.get_object('hal_meter3')
		self.meter3.min = mmin	

## Qui assegna di base i valori della sala prove:
		self.builder.get_object('BX').set_value(2800)
		self.builder.get_object('CX').set_value(2800)
		self.builder.get_object('CY').set_value(2000)
		self.builder.get_object('DY').set_value(2000)

## Creazione pin valori spinbutton:
		self.spin1_out = halcomp.newpin('spin1-out',  hal.HAL_FLOAT, hal.HAL_OUT)
		self.spin2_out = halcomp.newpin('spin2-out',  hal.HAL_FLOAT, hal.HAL_OUT)
		self.spin3_out = halcomp.newpin('spin3-out',  hal.HAL_FLOAT, hal.HAL_OUT)
		self.spin4_out = halcomp.newpin('spin4-out',  hal.HAL_FLOAT, hal.HAL_OUT)
		self.spin1_value = self.builder.get_object('BX')
		self.spin2_value = self.builder.get_object('CX')
		self.spin3_value = self.builder.get_object('CY')
		self.spin4_value = self.builder.get_object('DY')

## Quando tolgo l'estop chiama la funzione:
		self.on_estop_reset = hal_glib._GStat()
		self.on_estop_reset.connect('state-estop-reset', self._on_estop_reset)

def get_handlers(halcomp,builder,useropts):

	global debug
	for cmd in useropts:
		exec cmd in globals()

	set_debug(debug)

	return [HandlerClass(halcomp,builder,useropts)]
